﻿namespace Arch.Common.Data.Cache
{
    public interface ICacheStore
    {
        string Name { get; set; }

        void Add(string key, object value);
        void Add(string key, object value, int seconds);
        void Add(string key, object value, int seconds, CachePriority priority);
        void Add(string key, object value, CachePriority priority);

        object Get(string key);
        void Remove(string key);
        bool Contains(string key);

        void Flush();
    }
}
