﻿using System;
using System.Diagnostics;

namespace Arch.Common.Data.Trace
{
    public interface ITraceStore
    {
        string Name { get; set; }
        bool IsRecursive { get; set; }

        void Log(string message, TraceEventType type);
        void Log(string message, TraceEventType type, Exception ex);
        void Debug(string message);
        void Debug(string message, Exception ex);
        void Error(string message);
        void Error(string message, Exception ex);
        void Info(string message);
        void Info(string message, Exception ex);
        void Warning(string message);
        void Warning(string message, Exception ex);
        void Critical(string message);
        void Critical(string message, Exception ex);
    }
}
