﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Arch.Aspects
{
    [AttributeUsage(AttributeTargets.Class)]
    public class Validate : Attribute
    {
        public IEnumerable<string> Includes { get; set; }
        public bool ApplyValidation { get; set; }

        public Validate() : this(new string[0]) { }
        public Validate(bool applyValidation) : this(applyValidation, new string[0]) { }
        public Validate(params string[] includes) : this(false, includes) { }

        public Validate(bool applyValidation, params string[] includes)
        {
            ApplyValidation = applyValidation;
            Includes = includes;
        }
    }
}
