﻿using System;
using System.Windows;
using System.Windows.Data;

namespace Arch.Samples.RiaServices.Helpers
{
    public class DataContextProxy : FrameworkElement
    {
        public DataContextProxy()
        {
            Loaded += DataContextProxyLoaded;
        }

        void DataContextProxyLoaded(object sender, RoutedEventArgs e)
        {
            Binding binding = new Binding();
            if (!String.IsNullOrEmpty(BindingPropertyName))
            {
                binding.Path = new PropertyPath(BindingPropertyName);
            }
            binding.Source = this.DataContext;
            binding.Mode = BindingMode;
            this.SetBinding(DataContextProxy.SourceProperty, binding);
        }

        public Object Source
        {
            get { return (Object)GetValue(SourceProperty); }
            set { SetValue(SourceProperty, value); }
        }

        public static readonly DependencyProperty SourceProperty =
            DependencyProperty.Register("Source", typeof(Object), typeof(DataContextProxy), null);

        public string BindingPropertyName { get; set; }

        public BindingMode BindingMode { get; set; }
    }
}
